var LOGFILE_NAME = "remote-connectivity-startup.log";
var lInfo = {logln:function (o){}};
//lInfo = new Logger(LOGFILE_NAME);
var lWarn = new Logger(LOGFILE_NAME);

Property.load();

function getdSHubToken() {
    var dSHubToken = '';
    try {
        var h = new HTTP( { 'debug' : 0 }, {});
        lInfo.logln("call json/system/requestApplicationToken");
        var code = h.get('http://127.0.0.1:8088/json/system/requestApplicationToken?applicationName=dSHub', '');
        if (code.status.valueOf() === 200) {
            var oAnswer=JSON.parse(code.body);
            if(oAnswer.ok == true){
                var result = oAnswer.result;
                dSHubToken = result.applicationToken;
                lInfo.logln("--- received token : " + dSHubToken);
            } else {
                lWarn.logln('getApplicationToken: Error getting new application token');
            }
        } else {
            lWarn.logln('getApplicationToken: Error getting new application token, json call failed');
        }
    } catch (e){
        lWarn.logln('exception in getApplicationToken: ' + e);
    }
    return dSHubToken;
}

function enableToken(token) { 
    try {
        lInfo.logln("Enable token : " + token);
        RemoteConnectivity.enableToken(token);
    } catch (e){
        lWarn.logln('exception in enableToken: ' + e);
    }
}

function convertRemoteConnectivity() {
    var dSToken = getdSHubToken();
    if (dSToken != '') {
        enableToken(dSToken)
    } else {
        lWarn.logln('getting dSHub token failed');
        return false;
    }
    lInfo.logln("Now activate dSHub Connection with token: " + dSToken);
    RemoteConnectivity.ActivatedSHubConnectivity(dSToken, function (result){
        if (result!=null) {
            lInfo.logln('ActivatedSHubConnectivity returned');
            if (result.ReturnCode == 0) {
                if ((result.Response!=null) && (result.Response.IsActivated == true)){
                    Property.setProperty('dSToken', dSToken);
                    Property.setFlag('dSToken', 'ARCHIVE', true);
                    Property.store();
                } else {
                    revokeToken(dSToken);
                }
            } else {
                lWarn.logln('--ReturnCode != 0: ' + result.ReturnCode);
            }
        } else {
            lWarn.logln('ActivatedSHubConnectivity call failed');
        }

    });
    return true;
}

if (Property.getNode('OSPToken') != null) {
    if (Property.getNode('dSToken') == null) {
        convertRemoteConnectivity();
    }
}
